zoj2432 hdoj1423 最长公共上升子序列(LCIS)

zoj2431  http://acm.zju.edu.cn/onlinejudge/showProblem.do?problemCode=2432

hdoj 1423 http://acm.hdu.edu.cn/showproblem.php?pid=1423

题意:

一看题目题意就很明显了, 两个数组a,b,求出两个数组公共的最长的上升子序列(可以不是连续的子序列)。

分析:

如果做过[最长公共子序列](http://blog.csdn.net/wangdan11111/article/details/41321277)应该更容易明白点。

定义状态d[i][j]表示以a数组的前i个元素,b数组的前j个元素并且以b[j]为结尾的LCIS的长度。

首先:a[i] != b[j]时, d[i][j] = d[i-1][j];   因为 d[i][j] 是以 b[j] 为结尾的LCIS,如果 d[i][j] > 0 那么就说明 a[1] .... a[i] 中必然有一个元素 a[k] 等于 b[j]。因为 a[k] != a[i],那么 a[i] 对 d[i][j] 没有贡献,于是我们不考虑它照样能得出 d[i][j] 的最优值。所以在 a[i] != b[j] 的情况下必然有 d[i][j] = d[i-1][j]。这一点参考LCS的处理方法。

当a[i]==b[j]时, 首先,这个等于起码保证了长度为1的LCIS。然后我们还需要去找一个最长的且能让b[j]接在其末尾的LCIS。之前最长的LCIS在哪呢?首先我们要去找的d数组的第一维必然是i-1。因为i已经拿去和b[j]配对去了,不能用了。第二维需要枚举 b[1] ... b[j-1]了,因为你不知道这里面哪个最长且哪个小于 b[j]。

状态转移方程:

a[i] != b[j]: d[i][j]=d[i-1][j] ;

a[i] == b[j]: d[i][j]=max(d[i-1][k]) + 1 ; (1<= k <= j-1)

不难看到,这是一个时间复杂度为O(n^3)的DP,离平方还有一段距离。

但是,这个算法最关键的是,如果按照一个合理的递推顺序,max(d[i-1][k])的值我们可以在之前访问 d[i][k] 的时候通过维护更新一个max变量得到。怎么得到呢?首先递推的顺序必须是状态的第一维在外层循环,第二维在内层循环。也就是算好了 d[1][n2] 再去算 d[2][1]。 如果按照这个递推顺序我们可以在每次外层循环的开始加上令一个max变量为0,然后开始内层循环。当a[i]>b[j]的时候令max = d[i-1][j]。如果循环到了a[i] == b[j]的时候,则令 d[i][j] = max+1。 最后答案是 d[n1][1] ... d[n1][n2]的最大值。

举个例子

a={1, 4, 2, 5, -12}   b ={5, -12, 1, 2, 4, 5}

        5      -12     1     2     4     5  
  1     0    0   1   0   0   0
  4      0    0   1   0   2   0
  2   0    0   1   2   2   0
  5   1    0   1   2   2   3
  -12   1    1   1   2   2   3

if(a[i] == b[j])

d[i][j] = mx + 1;

else  if(a[i] > b[j] && mx < d[i-1][j])

                  mx = d[i-1][j];

       //只有当a[i] > b[j]时,才更新mx, 保证了所求序列是上升的。

仔细看表格会发现: 若d[i][j] > 0 的话,那么在数组a前i个元素中一定存在a[k]( 1 <= k <= i)等于b[j]. 否则说明前i个a元素中没有与b[j]相同的元素。

zoj2432

#include<iostream>
#include<cstdio>
#include<string.h>
#include<cstring>
#include<math.h>
using namespace std;

const int N = 505;
int n1, n2, t, mx, sum;
int a[N], b[N], d[N][N], pi[N][N], pj[N][N];
void  dp()
{
    for(int i = 1; i <= n1; i++)
    {
        int mx = 0, x = 0, y = 0;
        for(int j = 1; j <= n2; j++)
        {
            d[i][j] = d[i-1][j];
            pi[i][j] = i-1;
            pj[i][j] = j;
            if(a[i] > b[j] && mx < d[i-1][j])
            {
                mx = d[i-1][j];
                x = i-1; y = j;
            }
            else if(a[i] == b[j])
            {
                d[i][j] = mx + 1;
                pi[i][j] = x;
                pj[i][j] = y;
            }
        }
    }
}
void ac(int x, int y)
{
    if(d[x][y] == 0)
        return;
    int fx = pi[x][y];
    int fy = pj[x][y];
    ac(fx, fy);
    if(d[x][y] != d[fx][fy] && y != 0)
    {
        printf("%d", b[y]);
        sum++;
        if(sum < mx) printf(" ");
        else
            printf("\n");
    }
}
int main()
{
    cin >> t;
    while(t--)
    {
        scanf("%d", &n1);
        for(int i = 1; i <= n1; i++) scanf("%d", &a[i]);
        scanf("%d", &n2);
        for(int i = 1; i <= n2; i++) scanf("%d", &b[i]);
        memset(d, 0, sizeof(d));
        memset(pi, -1, sizeof(pi));
        memset(pj, -1, sizeof(pj));
        dp();
        mx = 0;
        int flag = 0;
        for(int i = 1; i <= n2; i++)
        {
            if(d[n1][i] > mx)
            {
                mx = d[n1][i];
                flag = i;
            }
        }
        printf("%d\n", mx);
        for(int i = 1; i <= n1; i++)
        {
            for(int j = 1; j  <= n2; j++)
                printf("%d ", d[i][j]);
            printf("\n");
        }
        sum = 0;
        if(mx > 0)
            ac(n1, flag);
        if(t)
            printf("\n");
    }
    return 0;
}

hdoj1423

#include<iostream>
#include<cstdio>
#include<string.h>
#include<cstring>
#include<math.h>
using namespace std;

int n1, n2, t, k;
int a[505], b[505], d[505][505];
int dp()
{
    int mx;
    for(int i = 1; i <= n1; i++)
    {
        mx = 0;
        for(int j = 1; j <= n2; j++)
        {
            d[i][j] = d[i-1][j];
            if(a[i] > b[j] && mx < d[i-1][j]) mx = d[i-1][j];
            else if(a[i] == b[j])
                d[i][j] = mx + 1;
        }
    }
    mx = 0;
    for(int i = 1; i <= n2; i++)
    {
        if(d[n1][i] > mx)
             mx = d[n1][i];
    }
    return mx;
}
int main()
{
    cin >> t;
    while(t--)
    {
        scanf("%d", &n1);
        for(int i = 1; i <= n1; i++) scanf("%d", &a[i]);
        scanf("%d", &n2);
        for(int i = 1; i <= n2; i++) scanf("%d", &b[i]);
        memset(d, 0, sizeof(d));
        int ans = dp();
        printf("%d\n", ans);
        if(t) printf("\n");
    }
    return 0;
}

时间: 2024-12-08 13:40:25

zoj2432 hdoj1423 最长公共上升子序列(LCIS)的相关文章

最长公共上升子序列(LCIS)ZOJ 2432

立方算法: #include<cstdio> #include<iostream> #include<algorithm> #include<cstring> #define M 505 using namespace std; typedef long long LL; LL a[M],b[M]; int dp[M][M]; int main() { //freopen("in.txt","r",stdin); in

动态规划——最长公共上升子序列LCIS

问题 给定两个序列A和B,序列的子序列是指按照索引逐渐增加的顺序,从原序列中取出若干个数形成的一个子集,若子序列的数值大小是逐渐递增的则为上升子序列,若A和B取出的两个子序列A1和B1是相同的,则A1/B1为A和B的公共子序列.求出A和B的最长公共上升子序列. 分析     结合最长公共子序列和最长上升子序列来解决这个问题,定义状态dp[i][j]表示A串中前i个字符和B串中前j个字符且以B[j]为结尾的最长公共上升子序列的长度.则有状态转移方程:[在进行动态规划状态的设计的时候,要简单.详尽的

最长公共上升子序列||LCIS

1 #include<cstdio> 2 #include<iostream> 3 #include<cstdlib> 4 #include<cmath> 5 #include<vector> 6 #include<algorithm> 7 #include<cstring> 8 #include<vector> 9 #include<map> 10 #include<stack> 11

HDU1423 最长公共上升子序列LCIS

Problem Description This is a problem from ZOJ 2432.To make it easyer,you just need output the length of the subsequence. Input Each sequence is described with M - its length (1 <= M <= 500) and M integer numbers Ai (-2^31 <= Ai < 2^31) - the

Codeforces 10D LCIS 求最长公共上升子序列及输出这个子序列 dp

题目链接:点击打开链接 题意: 给定n长的一个序列 再给定k长的一个序列 求LCIS并输出这个子序列 如有多解输出任意解.. = - = 敲的时候听着小曲儿pre的含义还没有想清楚,万万没想到就过了... #include<stdio.h> #include<iostream> #include<string.h> #include<set> #include<vector> #include<map> #include<mat

HDU 4512 吉哥系列故事——完美队形I(LCIS最长公共上升子序列)

http://acm.hdu.edu.cn/showproblem.php?pid=4512 题意: 吉哥这几天对队形比较感兴趣. 有一天,有n个人按顺序站在他的面前,他们的身高分别是h[1], h[2] ... h[n],吉哥希望从中挑出一些人,让这些人形成一个新的队形,新的队形若满足以下三点要求,则称之为完美队形: 1.挑出的人保持他们在原队形的相对顺序不变: 2.左右对称,假设有m个人形成新的队形,则第1个人和第m个人身高相同,第2个人和第m-1个人身高相同,依此类推,当然,如果m是奇数,

最长公共上升子序列(LCIS)问题的O(n^2)解法

J - 病毒 Time Limit:3000MS     Memory Limit:131072KB     64bit IO Format:%lld & %llu Submit Status Practice CSU 1120 Appoint description:  System Crawler  (2015-01-04) Description 你有一个日志文件,里面记录着各种系统事件的详细信息.自然的,事件的时间戳按照严格递增顺序排列(不会有两个事件在完全相同的时刻发生). 遗憾的是,

HDU ACM 4512 吉哥系列故事——完美队形I -&gt;LCIS最长公共递增子序列

分析:最长公共递增子序列,把数据反向存储一遍,求正反两组数据的LCIS.另外注意边界的条件判断.还有如果取出的新队列有奇数个人或偶数个人要单独判断. #include<iostream> using namespace std; #define max(a,b) ((a)>(b)?(a):(b)) int dp[202]; int a[202]; int b[202]; int LCIS(int n) { int i,j,maxlen,ans; memset(dp,0,sizeof(dp

[CodeForces10D]LCIS(最长公共上升子序列) - DP

Description 给定两个数列,求最长公共上升子序列,并输出其中一种方案. Input&Output Input 第一行一个整数n(0<n<=500),数列a的长度. 第二行n个空格隔开的整数,数列a的元素. 第三行一个整数m,数据范围同n,数列b的长度. 第四行m个空格隔开的整数,意义同第二行. Output 第一行一个整数k,LCIS的长度. 第二行k个空格隔开的整数,其中一种方案. Solution 对于这类问题我们通常有两种转移方式,一种是以i结尾的数列,另一种是前i个数